# Citadelle

## Authors
* [Achim D. Brucker](http://www.brucker.ch/)
* Frédéric Tuong
* [Burkhart Wolff](https://www.lri.fr/~wolff/)

## Acronyms of Citadelle
Due to space and unlimited tweaking reasons, all known acronyms of
Citadelle (only those judged gorgeous) were deconstructed, once and
for all, then sorted together:
* and - AST - Castra - Cementing - Citadelle - Coding - Constructive -
  Costras - Down - Earth's - Fortify - Generic - in - Invalid's -
  Isabelle - Isabelle's - Languages' - Meta - ML-like's - Models -
  Null's - Reflected - Supporting - to - Top - Transformer - UML/OCL's

The creation of the initial acronyms were nevertheless following
certain rules relieving from combinatorial blow-ups, for instance:
* Length: Unrestricted, but to fit in a top header file, first line
  words are arranged to total less than N characters without breaking
  any words, and for subsequent lines: N + the length of Citadelle.
* Order: They all contain in case insensitive increasing ordering the
  title letters Citadelle.
* Sonority: Each element of the list is normally used only once, but
  elements with similar consonances can be better consecutively
  regrouped to reverberate the melody Citadelle.
* Tail Recursivity: Each acronym has in its ending tail position the
  supposedly reflect of itself, namely Citadelle.
* Persistence: By clearing away the last and generally all words
  Citadelle, it is still possible to find at least another hidden
  sequence of Citadelle.
* Laziness: Here, avoiding laziness is as simple as: starting to
  mention the title letters somewhere, and finally starting to make
  all rules embellishing themselves to the point of gorgeousness.

## License
This project is licensed under a 3-clause BSD-style license.
